//--redFrik 20140121

//related: RedRead

RedWrite {
	classvar >path= "/tmp/redringbuffer";
	classvar bufferSize= 10;
	classvar allFunc;
	var func;
	*initClass {
		allFunc= List.new;
	}
	*stopAll {
		allFunc= List.new;
	}
	*new {|name= ""|
		^super.new.initRedWrite(name);
	}
	initRedWrite {|name|
		var pathname= path++name, index= 0;
		if(thisProcess.interpreter.preProcessor.isNil, {
			thisProcess.interpreter.preProcessor= {|code|
				allFunc.do{|x| x.value(code)};
				code;
			};
		});
		func= {|code|
			var file, next;
			file= File(pathname++index, "w");
			file.write(code);
			file.close;
			index= index+1%bufferSize;
			next= pathname++index;
			File.delete(next);
		};
		ShutDown.add({
			bufferSize.do{|i| File.delete(pathname++i)};
		});
		allFunc.add(func);
	}
	stopWriting {
		allFunc.remove(func);
	}
}
